<?php

namespace Teknisa\SUP\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Response;
use Teknisa\SUP\Util\SupUtilities;
use Zeedhi\Framework\DataSource\DataSet;

class DiasEntregaController extends \Teknisa\GER\Controllers\TeknisaCrud
{
    protected $dataSourceName = 'diasentr';
    protected $crudService;
    private $supUtilities;
    
    public function __construct($crudService, $parameterBag, $supUtilities)
    {
        parent::__construct($crudService, $parameterBag);
        $this->crudService  = $crudService;
        $this->supUtilities = $supUtilities;
    }
    
    public function find(Filter $request, Response $response)
    {
        $row = $this->supUtilities->getParametersFromCondititions($request);
        
        
        $conditions = array_filter($request->getFilterCriteria()->getConditions(), function($condition) {
            return $condition['columnName'] == 'CDPERIENTR';
        }, ARRAY_FILTER_USE_BOTH);
        
        switch (self::validaTipoDiaGravaDataDeConsumo($row)) {
            case 'S':
                $this->dataSourceName = 'dias_consumo';
                break;
                
            case 'M':
                $this->dataSourceName = 'mes_consumo';
                break;
            
            case "":
                $this->dataSourceName = 'diasentr';
                break;
        }
        $diasConsumo = $this->crudService->getFilteredDataSet($this->dataSourceName, $conditions)->getRows();
        
        $response->addDataSet(new DataSet($this->dataSourceName, $diasConsumo));
    }
    
    public function validaTipoDiaGravaDataDeConsumo($row)
    {
        return !empty($row) && 
            (array_key_exists ('IDGRAVADTCONSUM', $row) && $row['IDGRAVADTCONSUM'] == "S") ?
            $row['IDTIPODIA'] : "";
    }
}